<?php
    require_once '../datab.php';
    require_once '../fpdf/fpdf.php';

    if(isset($_GET['patient_record_id'])){
        $ip_id = $_GET['patient_record_id'];
        $bill_no_db = $_GET['bill_no'];

    }

    $sql = mysqli_query($conn, "SELECT iodb.*, pd.*, ob.*, ob.sub_total, DATE_FORMAT(iodb.dateTime, '%d-%m-%Y') as admit_date, DATE_FORMAT(iodb.discharge_date, '%d-%m-%Y') AS discharge_date
                                FROM ob_billing ob
                                JOIN ip_ob_entry_data iodb ON iodb.id = ob.patient_record_id 
                                JOIN patient_data pd ON pd.id = iodb.patient_id
                                WHERE ob.patient_record_id = '$ip_id'");

    $select_divisions = mysqli_query($conn, "SELECT obsf.amount, sc.scan_cat_name, s.scan_name, obsf.qty
                                            FROM ob_scan_paid obsf
                                            JOIN scan_cat sc ON obsf.division_id = sc.id
                                            JOIN scan s ON sc.scan_id = s.id
                                            WHERE patient_record_id='$ip_id'");


    if($row = mysqli_fetch_assoc($sql)){

        $patient_name = $row['patient_name'];
        $mrd_no = $row['mrd_no'];

        $dob = new DateTime($row['dob']);
        $today = new DateTime();
        $ageInterval = $today->diff($dob);
        $age = $ageInterval->y;

        $address = $row['address'];

        $bill_date = date("d-m-Y");

        $admit_date = $row['admit_date'];
        $discharge_date = $row['discharge_date'];


        $bill_date_no = date("Ymd", strtotime($dateTime)); 
        $bill_no_db_formatted = sprintf("%04d", $bill_no_db);
        $bill_no = $bill_date_no.$bill_no_db_formatted;

        // $va_date = $row['admission_date'];

        $total = $row['total'];
        $sub_total =$row['sub_total'];
        $advance = $row['ad_amount'];

        $less = $row['less'];
        // $charge = $row['service_charge'];

        $service_charge = $sub_total - $less;

        $bill_no_update_ip_ob_entry_data = mysqli_query($conn, "UPDATE ip_ob_entry_data SET `bill_no`='$bill_no' WHERE id='$ip_id'"); 

        $sql2 = mysqli_query($conn, "SELECT * FROM ob_bill_services WHERE patient_record_id='$ip_id'");
    }

    if (!file_exists('../ob_bill/' . $ip_id)) {
        mkdir('../ob_bill/' . $ip_id, 0777, true);
    }
    

    class PDF extends FPDF
    {
        function Header()
        {
            $this->Image('dummy.png', 10, 6, 30);

            $this->SetFont('Arial', 'B', 15);
            $this->SetX(50);
            $this->MultiCell(100, 10, 'New Aarthy Hospital');
            
            $this->SetFont('Arial', '', 8);
            $this->SetXY(50, 20);
            $this->MultiCell(100, 5, '3A/108, Bharathiar Salai, Cantonment,',0);

            $this->SetX(50);
            $this->MultiCell(50, 5, 'Trichy - 620 001,',0);

            // $this->SetX(50);
            // $this->MultiCell(50, 5, 'Tamil Nadu - 620001,',0);
            

            $this->SetX(50);
            $this->MultiCell(50, 5, 'PH: 04312414369, AVAILABLE 24/7.');

            $this->Ln(5);

            $this->Line(10, $this->GetY(), 200, $this->GetY());

            $this->Ln(3);
        }
    
        // Page footer
        function Footer()
        {
            $this->SetY(-15);
            $this->SetFont('Arial', 'I', 8);
            $this->Cell(0, 10, 'Page ' . $this->PageNo() . '/{nb}', 0, 0, 'C');
        }
    }

    $pdf = new PDF('P', 'mm', 'A4');
    $pdf->AliasNbPages();
    $pdf->AddPage();

    $pdf->SetFont('Arial', 'B', 10);
    
    $row_1 = 10;
    $row_2 = 120;

    $row_1_length = 40;
    $row_11_length = 60;
    $row_2_length = 45;
    $row_21_length = 60;

    $row_start = $pdf->GetY();
    $pdf->MultiCell($row_1_length, 5, 'Patient MRD:');
    $pdf->SetXY($row_1+$row_1_length, $row_start);
    $pdf->MultiCell($row_11_length, 5, $mrd_no);

    $y_temp = $pdf->GetY();
    $pdf->MultiCell($row_1_length, 5, 'Patient Name:');
    $pdf->SetXY($row_1+$row_1_length, $y_temp);
    $pdf->MultiCell($row_11_length, 5, $patient_name);

    $y_temp = $pdf->GetY();
    $pdf->MultiCell($row_1_length, 5, 'Patient Age:');
    $pdf->SetXY($row_1+$row_1_length, $y_temp);
    $pdf->MultiCell($row_11_length, 5, $age);

   
    if (!empty($address)) 
    {
        $y_temp = $pdf->GetY();
        $pdf->MultiCell($row_1_length, 5, 'Address:');
        $pdf->SetXY($row_1+$row_1_length, $y_temp);
        $pdf->MultiCell($row_11_length, 5, $address);
    }
    else
    {
        $pdf->Ln(5);
    }
    

    // $pdf->Ln(7);
    // $y_temp = $pdf->GetY();
    // $pdf->MultiCell($row_1_length, 5, 'Consulted Doctor:');
    // $pdf->SetXY($row_1+$row_1_length, $y_temp);
    // $pdf->MultiCell($row_11_length + $row_2_length + $row_21_length, 5, 'Dr.'.$doctor_name.' '.$specialization);

    $end_row = $pdf->GetY() + 8;

    // next line starts

    $pdf->SetXY($row_1 + $row_1_length + $row_11_length, $row_start);
    $pdf->MultiCell($row_2_length, 5, 'Bill  No:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $row_start);
    $pdf->MultiCell($row_21_length, 5, $bill_no);

    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->MultiCell($row_2_length, 5, 'Bill Date:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->MultiCell($row_21_length, 5, $bill_date);

    $y_temp = $pdf->GetY();
    $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    $pdf->MultiCell($row_2_length, 5, 'Admit Date:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    $pdf->MultiCell($row_21_length, 5, $admit_date);

    $y_temp = $pdf->GetY();
    $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    $pdf->MultiCell($row_2_length, 5, 'Discharge Date:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    $pdf->MultiCell($row_21_length, 5, $discharge_date);
    

    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->MultiCell($row_2_length, 5, 'Visit / Admission No:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->MultiCell($row_21_length, 5, '1');


    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->MultiCell($row_2_length, 5, 'Visit / Admission Date:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->MultiCell($row_21_length, 5, $va_date);

    
    $pdf->SetY($end_row);
    $pdf->SetFont('Arial', 'B', 15);
    $pdf->MultiCell(190, 8, 'BILL COPY', 0, 'C');

    $pdf->Line(10,$pdf->GetY(),200,$pdf->GetY());

    $pdf->Ln(2);

    $particulars_height = $pdf->GetY();
    $pdf->SetX(10);
    $pdf->SetFont('Arial', 'B', 11);
    $pdf->MultiCell(50, 5, 'Particulars');

    $pdf->SetXY(80, $particulars_height);
    $pdf->MultiCell(50, 5, 'Quantity', '0', 'C');

    $pdf->SetXY(180, $particulars_height);
    $pdf->MultiCell(20, 5, 'Amount','0','R');

    $pdf->SetY($particulars_height);

    $pdf->Ln(7);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());
    $line_4 = $pdf->GetY() + 3;
    $line_4_inc = 8;

    $totalServices = 0;
    $totalAmount = 0;

    $less = $row['less'];

    
    // Calculate the total amount and the number of services
    while($row2 = mysqli_fetch_assoc($sql2)) {
        $service_name = $row2['service_name'];
        $service_amount = $row2['service_amount'];
    
        $totalServices++;
        $totalAmount += $service_amount;
    }

    while ($division_row = mysqli_fetch_assoc($select_divisions)) {
        $amount = $division_row['amount'];
        $division_name = $division_row['scan_cat_name'];
        $i_name = $division_row['scan_name'];
        $d_qty = $division_row['qty'];


        $totalAmount += $amount;

        $percentage = ($amount / $totalAmount) * 100;

        $discountedPercentage = ($percentage / 100) * $less;

        $discountedAmount = $amount - $discountedPercentage;
        
        $pdf->SetFont('Arial', '', 10);

        $discountedAmountFormatted = number_format($discountedAmount, 2, '.', '');
        $pdf->SetXY(10, $line_4);
        $pdf->MultiCell($row_2, 5, $i_name." - ".$division_name,'0','L');

        $pdf->SetXY(100, $line_4);
        $pdf->MultiCell(10, 5, $d_qty ,'0','C');


        $pdf->SetXY(180, $line_4);
        $pdf->MultiCell(20, 6, $discountedAmountFormatted, '0', 'R');
        
        $line_4 += $line_4_inc;
    }


    
    // Calculate the discount per service
    $discountPerService = ($less > 0) ? $less / $totalServices : 0;
    
    // Reset the pointer to the beginning of the result set
    mysqli_data_seek($sql2, 0);
    
    
    while($row2 = mysqli_fetch_assoc($sql2)) {
        $service_name = $row2['service_name'];
        $s_qty = $row2['qty'];
        $service_amount = $row2['service_amount'];

    
        $percentage = ($service_amount / $totalAmount) * 100;
        $discountedPercentage = ($percentage / 100) * $less;
        $discountedAmount = $service_amount - $discountedPercentage;  
        
        $discountedAmountFormatted = number_format($discountedAmount, 2, '.', '');

        $pdf->SetXY(10, $line_4);
        $part_cont_start = $pdf->GetY();
        $pdf->SetFont('Arial', '', 10);
        $pdf->MultiCell(100, 6, $service_name);

        $pdf->SetXY(100, $line_4);
        $pdf->MultiCell(10, 5, $s_qty, '0','C');
    
        $pdf->SetXY(180, $part_cont_start);
        $pdf->MultiCell(20, 6, $discountedAmountFormatted, '0', 'R');
        $line_4 += $line_4_inc;

    }
    
    
   

    $pdf->Ln(20);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());

    $pdf->Ln(5);
    $pdf->SetFont('Arial', '', 10);

    // $pdf->SetX(140);
    // $y_len = $pdf->GetY();
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell(45, 5, 'Total BIll Amount:', '0','R');
    // $pdf->SetXY(180,$y_len);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell(20, 5, $sub_total, '0','R');

    // $pdf->SetX(140);
    // $y_len = $pdf->GetY();
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell(45, 5, 'Advance:', '0','R');
    // $pdf->SetXY(180,$y_len);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell(20, 5, $advance, '0','R');

    $pdf->SetX(140);
    $y_len = $pdf->GetY();
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell(45, 5, 'Total Payable Amount:', '0','R');
    $pdf->SetXY(180,$y_len);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell(20, 5, $total, '0','R');

    $pdf->SetX(130);
    
    $number = $total;
    $no = floor($number);
    
    if ($no == $number) {
        $point = 0;
    } else {
        $point = ($number - $no) * 100;
        $point = round($point);
    }
    
    $hundred = null;
    $digits_1 = strlen($no);
    $i = 0;
    $str = array();
    $words = array('0' => '', '1' => 'One', '2' => 'Two',
        '3' => 'Three', '4' => 'Four', '5' => 'Five', '6' => 'Six',
        '7' => 'Seven', '8' => 'Eight', '9' => 'Nine',
        '10' => 'Ten', '11' => 'Eleven', '12' => 'Twelve',
        '13' => 'Thirteen', '14' => 'Fourteen',
        '15' => 'Fifteen', '16' => 'Sixteen', '17' => 'Seventeen',
        '18' => 'Eighteen', '19' => 'Nineteen', '20' => 'Twenty',
        '30' => 'Thirty', '40' => 'Forty', '50' => 'Fifty',
        '60' => 'Sixty', '70' => 'Seventy',
        '80' => 'Eighty', '90' => 'Ninety');
    $digits = array('', 'Hundred', 'Thousand', 'Lakh', 'Crore');
    
    while ($i < $digits_1) {
        $divider = ($i == 2) ? 10 : 100;
        $number = floor($no % $divider);
        $no = floor($no / $divider);
        $i += ($divider == 10) ? 1 : 2;
    
        if ($number) {
            $plural = (($counter = count($str)) && $number > 9) ? 's' : null;
            $hundred = ($counter == 1 && $str[0]) ? ' and ' : null;
            $str [] = ($number < 21) ? $words[$number] .
                " " . $digits[$counter] . $plural . " " . $hundred
                :
                $words[floor($number / 10) * 10]
                . " " . $words[$number % 10] . " "
                . $digits[$counter] . $plural . " " . $hundred;
        } else $str[] = null;
    }
    
    $str = array_reverse($str);
    $result = implode('', $str);
    
    if ($point > 20) {
        $two_deci = floor($point / 10) * 10;
        $rem = ceil($point) % 10;
        $first_point = $words[$two_deci] . " " . $words[$rem] . ' Paise only';
    } else {
        $first_point = $words[$point] . ' Paise only';
    }
    
    $points = ($point) ?
        " and " . $first_point : 'only';
    
    $pdf->Ln(5);

    $pdf->SetX(10);
    $pdf->SetFont('Arial', 'I', 10);
    $pdf->MultiCell(100, 5, 'Amount in words:');
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell(100, 5, $result . 'Rupees ' . $points);

    $pdf->Ln(3);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());
    
    // $pdf->Output();

    $pdfFileName = 'ob_bill.pdf';
    $filePath = '../ob_bill/' . $ip_id . '/' . $pdfFileName;
    $pdf->Output($filePath, 'F');
    $pdf->Output($filePath, 'I');

?>