<?php
    require_once '../datab.php';
    require_once '../fpdf/fpdf.php';

    if(isset($_GET['patient_record_id'])){
        $op_id = $_GET['patient_record_id'];
        $bill_no_db = $_GET['bill_no'];

    }

    $sql = "SELECT op.total, pd.*, dd.doctor_name, dd.specialization, op.less, opd.doc_fee, op.sub_total, op.total, op.bsugar_fee, (dd.amount) AS doc_fee_ad 
            FROM op_billing op 
            JOIN op_entry_data opd ON opd.id = op.patient_record_id
            JOIN patient_data pd ON pd.id = opd.patient_id
            JOIN doctor_data dd ON dd.id = opd.doctor_id
            WHERE op.patient_record_id='$op_id'";
    
    if($result = mysqli_query($conn, $sql))
    {
        
        $row = mysqli_fetch_assoc($result);
        $patient_name = $row['patient_name'];
        $address = $row['address'];


        $total = $row['total'];
        $sub_total = $row['sub_total'];
        $less = $row['less'];
        $doc_fee_admin = $row['doc_fee_ad'];

        $doc_fee = $row['doc_fee'] != 0 ? $row['doc_fee'] : $doc_fee_admin;


        $bsugar_fee = $row['bsugar_fee'] != 0 ? $row['bsugar_fee'] : 0;

        $d_b_l_amount = $doc_fee + $bsugar_fee - $less;
        $d_b_amount = $doc_fee + $bsugar_fee - $less;

        $doctor_name = $row['doctor_name'];
        $specialization = $row['specialization'];

        $dob = new DateTime($row['dob']);
        $today = new DateTime();
        $ageInterval = $today->diff($dob);
        $age = $ageInterval->y;

        $V_A_date = $row['dateTime'];
        $visit_date = date("d-m-Y", strtotime($V_A_date));

        $bill_date = date("d-m-Y");

        $bill_date_no = date("Ymd", strtotime($dateTime)); 
        $bill_no_db_formatted = sprintf("%04d", $bill_no_db);
        $bill_no = $bill_date_no.$bill_no_db_formatted;

        $bill_no_update_ip_ob_entry_data = mysqli_query($conn, "UPDATE op_entry_data SET `bill_no`='$bill_no' WHERE id='$op_id'"); 


        $mrd = $row['mrd_no'];


        $select_divisions = mysqli_query($conn, "SELECT obsf.amount, sc.scan_cat_name, s.scan_name, obsf.qty
                                                    FROM op_scan_paid obsf
                                                JOIN scan_cat sc ON obsf.division_id = sc.id
                                                JOIN scan s ON sc.scan_id = s.id
                                                WHERE patient_record_id='$op_id'");

        $sql2 = mysqli_query($conn, "SELECT * FROM op_bill_services WHERE patient_record_id='$op_id'");

    }

    if (!file_exists('../op_bill/'.$op_id)) {
        mkdir('../op_bill/'.$op_id, 0777, true);
    }

    class PDF extends FPDF
    {
        function Header()
        {
            $this->Image('dummy.png', 10, 6, 30);

            $this->SetFont('Arial', 'B', 15);
            $this->SetX(50);
            $this->MultiCell(100, 10, 'New Aarthy Hospital');
            
            $this->SetFont('Arial', '', 8);
            $this->SetXY(50, 20);
            $this->MultiCell(100, 5, '3A/108, Bharathiar Salai, Cantonment,',0);

            $this->SetX(50);
            $this->MultiCell(50, 5, 'Trichy - 620 001,',0);

            // $this->SetX(50);
            // $this->MultiCell(50, 5, 'Tamil Nadu - 620001,',0);
            

            $this->SetX(50);
            $this->MultiCell(50, 5, 'PH: 04312414369, AVAILABLE 24/7.');

            $this->Ln(5);

            $this->Line(10, $this->GetY(), 200, $this->GetY());

            $this->Ln(3);
        }
    
        // Page footer
        function Footer()
        {
            $this->SetY(-15);
            $this->SetFont('Arial', 'I', 8);
            $this->Cell(0, 10, 'Page ' . $this->PageNo() . '/{nb}', 0, 0, 'C');
        }
    }

    $pdf = new PDF('P', 'mm', 'A4');
    $pdf->AliasNbPages();
    $pdf->AddPage();    

    $row_1 = 10;
    $row_2 = 120;

    $row_1_length = 40;
    $row_11_length = 60;
    $row_2_length = 45;
    $row_21_length = 60;

    $row_start = $pdf->GetY();
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1_length, 5, 'Patient MRD:');
    $pdf->SetXY($row_1+$row_1_length, $row_start);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_11_length, 5, $mrd);

    $y_temp = $pdf->GetY();
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1_length, 5, 'Patient Name:');
    $pdf->SetXY($row_1+$row_1_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_11_length, 5, $patient_name);

    $y_temp = $pdf->GetY();
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1_length, 5, 'Patient Age:');
    $pdf->SetXY($row_1+$row_1_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_11_length, 5, $age);

    if (!empty($address)) 
    {
        $y_temp = $pdf->GetY();
        $pdf->SetFont('Arial', 'B', 10);
        $pdf->MultiCell($row_1_length, 5, 'Address:');
        $pdf->SetXY($row_1+$row_1_length, $y_temp);
        $pdf->SetFont('Arial', '', 10);
        $pdf->MultiCell($row_11_length, 5, $address);
    }
    else
    {
        $pdf->Ln(5);
    }

    $pdf->Ln(7);
    $y_temp = $pdf->GetY();
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1_length, 5, 'Consulted Doctor:');
    $pdf->SetXY($row_1+$row_1_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_11_length + $row_2_length + $row_21_length, 5, 'Dr.'.$doctor_name.' '.$specialization);

    $end_row = $pdf->GetY() + 8;

    // next line starts

    $pdf->SetXY($row_1 + $row_1_length + $row_11_length, $row_start);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_2_length, 5, 'Bill  No:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $row_start);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_21_length, 5, $bill_no);

    $y_temp = $pdf->GetY();
    $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_2_length, 5, 'Bill Date:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_21_length, 5, $bill_date);

    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell($row_2_length, 5, 'Visit / Admission No:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell($row_21_length, 5, '1');


    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell($row_2_length, 5, 'Visit / Admission Date:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell($row_21_length, 5, $visit_date);

    
    $pdf->SetY($end_row);
    $pdf->SetFont('Arial', 'B', 15);
    $pdf->MultiCell(190, 8, 'BILL RECEIPT', 0, 'C');

    // $pdf->Ln(3);
    $pdf->Line(10,$pdf->GetY(),200,$pdf->GetY());

    $pdf->Ln(2);

    $start = 10;
    $row_1 = 15;
    $row_2 = 130;
    $row_3 = 45;

    $y_len = $pdf->GetY();

    $pdf->SetX($start);
    $pdf->SetFont('Arial', 'B', 11);
    // $pdf->MultiCell($row_1, 5, '#');

    $next = $start + $row_1;

    $pdf->SetY($y_len);
    $pdf->MultiCell($row_2, 5, 'Particular','0','L');

    $pdf->SetXY(80, $y_len);
    $pdf->MultiCell(50, 5, 'Quantity', '0', 'C');

    $next = $next + $row_2;

    $pdf->SetXY($next, $y_len);
    $pdf->MultiCell($row_3, 5, 'Amount','0','R');

    $pdf->Ln(3);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());

    // $count = 1;
    $y_len = $pdf->GetY() + 3;

    $pdf->SetFont('Arial', '', 10);
    // $pdf->SetXY($start,$y_len);
    // $pdf->MultiCell($row_1, 5, $count);

    $next = $start + $row_1;

    $totalServices = 0;
    $totalAmount = 0;
    $less = $row['less'];
    $totalAmount_s = 0;
    $total_division_amount = 0;

    $division_total = 0;
    $service_total = 0;

    while ($division_row = mysqli_fetch_assoc($select_divisions)) {
        $amount = $division_row['amount'];
        
        $division_total += $amount;
    }
    while ($row3 = mysqli_fetch_assoc($sql2)) {
        $service_amount = $row3['service_amount'];

        $service_total += $service_amount;
    }

    $total_amount = $division_total + $service_total + $doc_fee + $bsugar_fee;
    
    // Calculate the total amount and the number of services

    while($row3 = mysqli_fetch_assoc($sql2)) {
        $service_name = $row3['service_name'];
        $service_amount = $row3['service_amount'];
        
        // $totalAmount_s += $service_amount;
    }


    $pdf->SetFont('Arial', '', 10);
    $pdf->SetXY(10, $y_len);
    $pdf->MultiCell($row_2, 5, 'Consultation Fee','0','L');
    $pdf->Ln(1);
    $next = $next + $row_2;

    $percentage_d = ($doc_fee / $total_amount) * 100;
        
    $discountedPercentage_d = ($percentage_d / 100) * $less;

    $discountedAmount_d = $doc_fee - $discountedPercentage_d;  
    
    $discountedAmountFormatted_d = number_format($discountedAmount_d, 2, '.', '');

    $pdf->SetXY($row_2+$start+$start+5, $y_len);
    $pdf->MultiCell($row_3, 5, sprintf('%.2f',$discountedAmountFormatted_d),'0','R');

    $line_4 = $pdf->GetY();
    $line_4_inc = 8;

    mysqli_data_seek($sql2, 0);
    
    while($row2 = mysqli_fetch_assoc($sql2) ) {
        // $count++;
        $service_name = $row2['service_name'];
        $s_qty = $row2['qty'];
        $service_amount = $row2['service_amount'];

        $percentage_s = ($service_amount / $total_amount) * 100;
        
        $discountedPercentage_s = ($percentage_s / 100) * $less;

        $discountedAmount_s = $service_amount - $discountedPercentage_s;  
        
        $discountedAmountFormatted_s = number_format($discountedAmount_s, 2, '.', '');

        // $line_4 += 1;

        // $pdf->SetXY($start,$line_4);
        // $pdf->MultiCell($row_1, 5, $count);

        $next = $start + $row_1;

        $pdf->SetXY(10, $line_4);
        $part_cont_start = $pdf->GetY();
        $pdf->SetFont('Arial', '', 10);
        $pdf->MultiCell(100, 6, $service_name);

        $pdf->SetXY(100, $line_4);
        $pdf->MultiCell(10, 5, $s_qty, '0','C');
    
        $line_4 += 5;
    
        $pdf->SetXY(180, $part_cont_start);
        $pdf->MultiCell(20, 6, $discountedAmountFormatted_s, '0', 'R');
        
    }

    if($bsugar_fee != 0)
    {
        // $count++;
        // $pdf->Ln(1);

        $y_len = $pdf->GetY();

        $percentage_b = ($bsugar_fee / $total_amount) * 100;
        
        $discountedPercentage_b = ($percentage_b / 100) * $less;

        $discountedAmount_b = $bsugar_fee - $discountedPercentage_b;  
        
        $discountedAmountFormatted_b = number_format($discountedAmount_b, 2, '.', '');
        
        // $pdf->SetXY($start,$y_len);
        // $pdf->MultiCell($row_1, 5, $count);

        $next = $start + $row_1;

        $pdf->SetXY(10, $y_len);
        $pdf->MultiCell($row_2, 5, 'Blood Sugar Fee','0','L');

        $next = $next + $row_2;

        $pdf->SetXY($next, $y_len);
        $pdf->MultiCell($row_3, 5, $discountedAmountFormatted_b,'0','R');
        
        // $count++;
        
        // $pdf->Ln(1);
    }

    $line_4 = $pdf->GetY();

    $total_division_amount = 0;
    
    while ($division_row = mysqli_fetch_assoc($select_divisions)) {
        $amount = $division_row['amount'];
        
        $total_division_amount += $amount;
    }
    
    // $discountPerDivision = ($less > 0) ? $less / mysqli_num_rows($select_divisions) : 0;
    
    mysqli_data_seek($select_divisions, 0);
    
    while ($division_row = mysqli_fetch_assoc($select_divisions)) 
    {
        // $pdf->Ln(1);
        $division_name = $division_row['scan_cat_name'];
        $amount = $division_row['amount'];
        $i_name = $division_row['scan_name'];
        $d_qty = $division_row['qty'];

    
        $percentage = ($amount / $total_amount) * 100;
    
        $discountedPercentage = ($percentage / 100) * $less;

        $discountedAmount = $amount - $discountedPercentage;  
        
        $discountedAmountFormatted = number_format($discountedAmount, 2, '.', '');
    
        // $count++;

        $y_len = $pdf->GetY();
        
        // $pdf->SetXY($start,$y_len);
        // $pdf->MultiCell($row_1, 5, $count);

        $next = $start + $row_1;

        $pdf->SetXY(10, $y_len);
        $pdf->MultiCell($row_2, 5, $i_name."-".$division_name,'0','L');

        $next = $next + $row_2;

        $pdf->SetXY(100, $line_4);
        $pdf->MultiCell(10, 5, $d_qty ,'0','C');

        $pdf->SetXY($next, $y_len);
        $pdf->MultiCell($row_3, 5, $discountedAmountFormatted,'0','R');

        $line_4 = $pdf->GetY();
    }
    
    $total_amount = $total_amount - $less;

    // $total_bill_amount = $total_division_amount + $d_b_amount + $totalAmount_s;

    $pdf->Ln(5);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());

    $pdf->Ln(2);
    $pdf->SetFont('Arial', '', 10);

    
    $pdf->SetX(120);
    $y_len = $pdf->GetY();

    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell(45, 5, 'Total Payable Amount:', '0','R');
    $pdf->SetXY(180,$y_len);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell(20, 5, sprintf("%0.2f",$total_amount), '0','R');

    
    $pdf->SetX(130);
    $number = $total_amount;
    $no = floor($number);
    
    if ($no == $number) {
        $point = 0;
    } else {
        $point = ($number - $no) * 100;
        $point = round($point);
    }
    
    $hundred = null;
    $digits_1 = strlen($no);
    $i = 0;
    $str = array();
    $words = array('0' => '', '1' => 'One', '2' => 'Two',
        '3' => 'Three', '4' => 'Four', '5' => 'Five', '6' => 'Six',
        '7' => 'Seven', '8' => 'Eight', '9' => 'Nine',
        '10' => 'Ten', '11' => 'Eleven', '12' => 'Twelve',
        '13' => 'Thirteen', '14' => 'Fourteen',
        '15' => 'Fifteen', '16' => 'Sixteen', '17' => 'Seventeen',
        '18' => 'Eighteen', '19' => 'Nineteen', '20' => 'Twenty',
        '30' => 'Thirty', '40' => 'Forty', '50' => 'Fifty',
        '60' => 'Sixty', '70' => 'Seventy',
        '80' => 'Eighty', '90' => 'Ninety');
    $digits = array('', 'Hundred', 'Thousand', 'Lakh', 'Crore');
    
    while ($i < $digits_1) {
        $divider = ($i == 2) ? 10 : 100;
        $number = floor($no % $divider);
        $no = floor($no / $divider);
        $i += ($divider == 10) ? 1 : 2;
    
        if ($number) {
            $plural = (($counter = count($str)) && $number > 9) ? 's' : null;
            $hundred = ($counter == 1 && $str[0]) ? ' and ' : null;
            $str [] = ($number < 21) ? $words[$number] .
                " " . $digits[$counter] . $plural . " " . $hundred
                :
                $words[floor($number / 10) * 10]
                . " " . $words[$number % 10] . " "
                . $digits[$counter] . $plural . " " . $hundred;
        } else $str[] = null;
    }
    
    $str = array_reverse($str);
    $result = implode('', $str);
    
    if ($point > 20) {
        $two_deci = floor($point / 10) * 10;
        $rem = ceil($point) % 10;
        $first_point = $words[$two_deci] . " " . $words[$rem] . ' Paise only';
    } else {
        $first_point = $words[$point] . ' Paise only';
    }
    
    $points = ($point) ?
        " and " . $first_point : 'only';

    $rupees = $result . 'Rupees ' . $points;
    $crt_rupees = preg_replace('!\s+!', ' ', $rupees);
    
    $pdf->Ln(5);

    $pdf->SetX(10);
    $pdf->SetFont('Arial', 'I', 10);
    $pdf->MultiCell(100, 5, 'Amount in words:');
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell(100, 5, $crt_rupees);

    $pdf->Ln(3);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());


    $pdf->Ln(30);

    $start = 10;
    $row_1 = 25;
    $row_2 = 25;
    $row_3 = 110;
    $row_4 = 30;

    $y_temp = $pdf->GetY() + 3;

    $pdf->SetXY($start, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1, 5 , 'Date');
    
    $next_x = $start + $row_1;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_2, 5 , 'Mode');

    $next_x = $next_x + $row_2;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_3, 5 , 'Payment Description');

    $next_x = $next_x + $row_3;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_4, 5 , 'Paid Amount', 0 ,'R');

    $pdf->Ln(3);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());

    $y_temp = $pdf->GetY() + 3;

    
    $ttl_paid = 0;
    $sql = "SELECT * from op_transaction_history where record_id = '$op_id' ";
    $rec = mysqli_query($conn, $sql);
    while($data = mysqli_fetch_assoc($rec))
    {
        $pdf->SetXY($start, $y_temp);
        $pdf->SetFont('Arial', '', 10);
        $pdf->MultiCell($row_1, 5 , date('d-m-Y', strtotime($data['dateTime'])));
        
        $next_x = $start + $row_1;

        $pdf->SetXY($next_x, $y_temp);
        $pdf->MultiCell($row_2, 5 , $data['mop']);

        $pdf->Ln(3);
        $get_line = $pdf->GetY();

        $next_x = $next_x + $row_2;

        $pdf->SetXY($next_x, $y_temp);
        $pdf->MultiCell($row_3, 5 , 'OP Payment');

        $next_x = $next_x + $row_3;

        $pdf->SetXY($next_x, $y_temp);
        $pdf->MultiCell($row_4, 5 , $data['amount'], 0 ,'R');

        $y_temp = $pdf->GetY() + 3;

        $ttl_paid = $ttl_paid + $data['amount'];
    }

    $y_temp = $pdf->GetY() + 10;
    $next_x = $start + $row_1 + $row_2;
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->SetXY($next_x, $y_temp);
    $pdf->MultiCell($row_3, 5 , 'Total Paid Amount', 0 ,'R');

    $next_x = $next_x + $row_3;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->MultiCell($row_4, 5 , sprintf('%.2f',$ttl_paid), 0 ,'R');

    $pdfFileName = 'op_bill.pdf';
    $filePath = '../op_bill/' . $op_id . '/' . $pdfFileName;
    $pdf->Output($filePath, 'F');
    $pdf->Output($filePath, 'I');
?>