<?php
    require_once '../datab.php';
    require_once '../fpdf/fpdf.php';

    if(isset($_GET['patient_record_id'])){
        $ip_id = $_GET['patient_record_id'];
        // $bill_no_db = $_GET['bill_no'] || 0;
        $bill_no_db = isset($_GET['bill_no']) ? $_GET['bill_no'] : 0;
    }

    $sql = mysqli_query($conn, "SELECT iodb.*, pd.*, DATE_FORMAT(iodb.dateTime, '%d-%m-%Y') as admit_date, 
                        DATE_FORMAT(iodb.discharge_date, '%d-%m-%Y') AS discharge_date
                        FROM ip_ob_entry_data iodb
                        JOIN patient_data pd ON pd.id = iodb.patient_id
                        WHERE iodb.id = '$ip_id' ");

    if($row = mysqli_fetch_assoc($sql)){

        $patient_name = $row['patient_name'];
        $mrd_no = $row['mrd_no'];
        $dob = new DateTime($row['dob']);
        $today = new DateTime();
        $ageInterval = $today->diff($dob);
        $age = $ageInterval->y;
        $address = $row['address'];

        $doc_fee = intval($row['nurse_charge']);
        $nurse_fee = intval($row['nurse_charge']);
        $bed_fee =intval($row['bed_charge']);
        
        $va_date = date("d-m-Y");
        
        $total = isset($row['total']) ? $row['total'] : 0;
        $sub_total = isset($row['sub_total']) ? $row['sub_total'] : 0;
        $advance = isset($row['ad_amount']) ? $row['ad_amount'] : 0 ;
        
        $less = isset($row['less']) ? $row['less'] : 0;

        $admit_date = $row['admit_date'];
        $discharge_date = $row['discharge_date'];

        $bill_date = date("d-m-Y");
        $bill_date_no = date("Ymd", strtotime($dateTime)); 
        $bill_no_db_formatted = sprintf("%04d", $bill_no_db) || '0';
        $bill_no = $bill_date_no.$bill_no_db_formatted;

        $bill_no_update_ip_ob_entry_data = mysqli_query($conn, "UPDATE ip_ob_entry_data SET `bill_no`='$bill_no' WHERE id='$ip_id'");

        // $select_divisions = mysqli_query($conn, "SELECT osd.id, osd.division_id,sc.scan_cat_name, osd.amount, s.scan_name, osd.qty , osd.dateTime
        //                                         FROM ip_bill_scan osd
        //                                         JOIN scan_cat sc ON osd.division_id = sc.id
        //                                         JOIN scan s ON sc.scan_id = s.id 
        //                                         WHERE osd.patient_record_id='$ip_id' ");

        $select_divisions = mysqli_query($conn, "SELECT osd.id, osd.division_id, sc.scan_cat_name, osd.amount, s.scan_name, osd.qty, osd.dateTime
                                         FROM ip_bill_scan osd
                                         JOIN scan_cat sc ON osd.division_id = sc.id
                                         JOIN scan s ON sc.scan_id = s.id 
                                         WHERE osd.patient_record_id='$ip_id'
                                         ORDER BY osd.dateTime");

        $sql2 = mysqli_query($conn, "SELECT * FROM ip_bill_services WHERE patient_record_id='$ip_id'");

    }

    if(!file_exists('../ip_bill/'.$ip_id.'/')){
        mkdir('../ip_bill/'.$ip_id.'/');
    }    

    class PDF extends FPDF
    {
        function Header()
        {
            $this->Image('dummy.png', 10, 6, 30);

            $this->SetFont('Arial', 'B', 15);
            $this->SetX(50);
            $this->MultiCell(100, 10, 'New Aarthy Hospital');
            
            $this->SetFont('Arial', '', 8);
            $this->SetXY(50, 20);
            $this->MultiCell(100, 5, '3A/108, Bharathiar Salai, Cantonment,',0);

            $this->SetX(50);
            $this->MultiCell(50, 5, 'Trichy - 620 001,',0);

            // $this->SetX(50);
            // $this->MultiCell(50, 5, 'Tamil Nadu - 620001,',0);
            

            $this->SetX(50);
            $this->MultiCell(50, 5, 'PH: 04312414369, AVAILABLE 24/7.');

            $this->Ln(5);

            $this->Line(10, $this->GetY(), 200, $this->GetY());

            $this->Ln(3);
        }
    
        // Page footer
        function Footer()
        {
            $this->SetY(-15);
            $this->SetFont('Arial', 'I', 8);
            $this->Cell(0, 10, 'Page ' . $this->PageNo() . '/{nb}', 0, 0, 'C');
        }
    }

    $pdf = new PDF('P', 'mm', 'A4');
    $pdf->AliasNbPages();
    $pdf->AddPage();
    
    $row_1 = 10;
    $row_2 = 120;

    $row_1_length = 40;
    $row_11_length = 60;
    $row_2_length = 45;
    $row_21_length = 60;

    $row_start = $pdf->GetY();
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1_length, 5, 'Patient MRD:');
    $pdf->SetXY($row_1+$row_1_length, $row_start);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_11_length, 5, $mrd_no);

    $y_temp = $pdf->GetY();
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1_length, 5, 'Patient Name:');
    $pdf->SetXY($row_1+$row_1_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_11_length, 5, $patient_name);

    $y_temp = $pdf->GetY();
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1_length, 5, 'Patient Age:');
    $pdf->SetXY($row_1+$row_1_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_11_length, 5, $age);

   
    if (!empty($address)) 
    {
        $y_temp = $pdf->GetY();
        $pdf->SetFont('Arial', 'B', 10);
        $pdf->MultiCell($row_1_length, 5, 'Address:');
        $pdf->SetXY($row_1+$row_1_length, $y_temp);
        $pdf->SetFont('Arial', '', 10);
        $pdf->MultiCell($row_11_length, 5, $address);
    }
    else
    {
        $pdf->Ln(5);
    }
    

    // $pdf->Ln(7);
    // $y_temp = $pdf->GetY();
    // $pdf->MultiCell($row_1_length, 5, 'Consulted Doctor:');
    // $pdf->SetXY($row_1+$row_1_length, $y_temp);
    // $pdf->MultiCell($row_11_length + $row_2_length + $row_21_length, 5, 'Dr.'.$doctor_name.' '.$specialization);

    $end_row = $pdf->GetY() + 8;

    // next line starts

    $pdf->SetXY($row_1 + $row_1_length + $row_11_length, $row_start);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_2_length, 5, 'Bill  No:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $row_start);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_21_length, 5, $bill_no);

    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell($row_2_length, 5, 'Bill Date:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell($row_21_length, 5, $bill_date);

    $y_temp = $pdf->GetY();
    $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_2_length, 5, 'Admit Date:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_21_length, 5, $admit_date);

    $y_temp = $pdf->GetY();
    $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_2_length, 5, 'Discharge Date:');
    $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell($row_21_length, 5, $discharge_date);

    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell($row_2_length, 5, 'Visit / Admission No:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell($row_21_length, 5, '1');


    // $y_temp = $pdf->GetY();
    // $pdf->SetX($row_1 + $row_1_length + $row_11_length);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell($row_2_length, 5, 'Visit / Admission Date:');
    // $pdf->SetXY($row_1 + $row_1_length + $row_11_length + $row_2_length, $y_temp);
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell($row_21_length, 5, $va_date);

    
    $pdf->SetY($end_row);
    $pdf->SetFont('Arial', 'B', 15);
    $pdf->MultiCell(190, 8, 'BILL RECEIPT', 0, 'C');

    $pdf->Line(10,$pdf->GetY(),200,$pdf->GetY());

    $pdf->Ln(2);

    $particulars_height = $pdf->GetY();
    $pdf->SetX(10);
    $pdf->SetFont('Arial', 'B', 11);
    $pdf->MultiCell(50, 5, 'Particulars');

    // $pdf->SetXY(80, $particulars_height);
    // $pdf->MultiCell(50, 5, 'Quantity', '0', 'C');

    $pdf->SetXY(180, $particulars_height);
    $pdf->MultiCell(20, 5, 'Amount','0','R');

    $pdf->SetY($particulars_height);

    $pdf->Ln(7);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());
    $line_4 = $pdf->GetY() + 3;
    $line_4_inc = 8;

    $totalAmount = 0;

    $totalAmount += $doc_fee;
    $totalAmount += $nurse_fee;
    $totalAmount += $bed_fee;


    // Adding Doctor Fee
    $pdf->SetFont('Arial', '', 10);
    $pdf->SetXY(10, $line_4);
    $pdf->MultiCell(80, 5, 'Doctor Fee' , '0', 'L');
    $pdf->SetXY(180, $line_4);
    $pdf->MultiCell(20, 6, number_format($doc_fee, 2), '0', 'R');
    $line_4 += $line_4_inc;


    $pdf->SetXY(10, $line_4);
    $pdf->MultiCell(80, 5, 'Nurse Fee' , '0', 'L');
    $pdf->SetXY(180, $line_4);
    $pdf->MultiCell(20, 6, number_format($nurse_fee, 2), '0', 'R');
    $line_4 += $line_4_inc;


    $pdf->SetXY(10, $line_4);
    $pdf->MultiCell(80, 5, 'Bed Fee' , '0', 'L');
    $pdf->SetXY(180, $line_4);
    $pdf->MultiCell(20, 6, number_format($bed_fee, 2), '0', 'R');
    $line_4 += $line_4_inc;

    
    $totalServices = 0;
    // $less = $row['less'];
    $less = isset($row['less']) ? $row['less'] : 0;

    $currentDate = '';
    $division_total = 0;


    
    // Calculate the total amount and the number of services
    while($row2 = mysqli_fetch_assoc($sql2)) {
        $service_name = $row2['service_name'];
        $service_amount = $row2['service_amount'];
    
        $totalServices++;
        $totalAmount += $service_amount;
    }

    while ($division_row = mysqli_fetch_assoc($select_divisions)) {
        

        $amount = $division_row['amount'];
        $division_name = $division_row['scan_cat_name'];
        $i_name = $division_row['scan_name'];
        $d_qty = $division_row['qty'];
        $dateTimeDb = date('d-m-Y', strtotime($division_row['dateTime']));

        if ($dateTimeDb != $currentDate) {
            $currentDate = $dateTimeDb;
            $pdf->SetFont('Arial', 'B', 10);
            $pdf->SetXY(10, $line_4);
            $pdf->MultiCell(190, 5, $currentDate, '0', 'L');
            $line_4 += $line_4_inc;
        }
    
        $totalAmount += $amount;
        $percentage = ($amount / $totalAmount) * 100;
        $discountedPercentage = ($percentage / 100) * $less;
        $discountedAmount = $amount - $discountedPercentage;
        $discountedAmountFormatted = number_format($discountedAmount, 2);
    
        $pdf->SetFont('Arial', '', 10);
        $pdf->SetXY(10, $line_4);
        $pdf->MultiCell(80, 5, $i_name . " - " . $division_name, '0', 'L');
        $pdf->SetXY(100, $line_4);
        // $pdf->MultiCell(10, 5, $d_qty, '0', 'C');
        $pdf->SetXY(180, $line_4);
        $pdf->MultiCell(20, 6, $discountedAmountFormatted , '0', 'R');
    
        $line_4 += $line_4_inc;

       
    }
    
    
    // Calculate the discount per service
    $discountPerService = ($less > 0) ? $less / $totalServices : 0;
    
    // Reset the pointer to the beginning of the result set
    mysqli_data_seek($sql2, 0);

    $serv_currentDate = '';

    while($row2 = mysqli_fetch_assoc($sql2)) {
        $service_name = $row2['service_name'];
        $s_qty = $row2['qty'];
        $service_amount = $row2['service_amount'];
        $serv_dateTime = date('d-m-Y', strtotime($row2['dateTime']));

        if ($serv_dateTime != $serv_currentDate) {
            $serv_currentDate = $serv_dateTime;
            $pdf->SetFont('Arial', 'B', 10);
            $pdf->SetXY(10, $line_4);
            $pdf->MultiCell(190, 5, $serv_currentDate, '0', 'L');
            $line_4 += $line_4_inc;
        }

        $percentage = ($service_amount / $totalAmount) * 100;
        
        $discountedPercentage = ($percentage / 100) * $less;
        $discountedAmount = $service_amount - $discountedPercentage;  
        
        $discountedAmountFormatted = number_format($discountedAmount, 2);

        $part_cont_start = $pdf->GetY();

        $pdf->SetXY(10, $line_4);
        $pdf->SetFont('Arial', '', 10);
        $pdf->MultiCell(100, 6, $service_name);

        $pdf->SetXY(100, $line_4);
        // $pdf->MultiCell(10, 6, $s_qty, '0','C');
        
        $pdf->SetXY(180, $line_4);
        $pdf->MultiCell(20, 6, $discountedAmountFormatted, '0', 'R');
        $line_4 += $line_4_inc;
    }

    
    $line_4 = $pdf->GetY();
    
    $pdf->Ln(5);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());

    $pdf->Ln(5);
    $pdf->SetFont('Arial', '', 10);

    // $pdf->SetX(130);
    // $y_len = $pdf->GetY();
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell(45, 5, 'Total BIll Amount:', '0','R');
    // $pdf->SetXY(180,$y_len);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell(20, 5, $sub_total, '0','R');

    // $pdf->SetX(130);
    // $y_len = $pdf->GetY();
    // $pdf->SetFont('Arial', '', 10);
    // $pdf->MultiCell(45, 5, 'Advance:', '0','R');
    // $pdf->SetXY(180,$y_len);
    // $pdf->SetFont('Arial', 'B', 10);
    // $pdf->MultiCell(20, 5, $advance, '0','R');

    $pdf->SetX(130);
    $y_len = $pdf->GetY();
    $pdf->SetFont('Arial', '', 10);
    $pdf->MultiCell(45, 5, 'Total Payable Amount:', '0','R');
    $pdf->SetXY(180,$y_len);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell(20, 5, number_format($totalAmount, 2), '0','R');

    $pdf->SetX(130);
    
    $number = $totalAmount;
    $no = floor($number);
    
    if ($no == $number) {
        $point = 0;
    } else {
        $point = ($number - $no) * 100;
        $point = round($point);
    }
    
    $hundred = null;
    $digits_1 = strlen($no);
    $i = 0;
    $str = array();
    $words = array('0' => '', '1' => 'One', '2' => 'Two',
        '3' => 'Three', '4' => 'Four', '5' => 'Five', '6' => 'Six',
        '7' => 'Seven', '8' => 'Eight', '9' => 'Nine',
        '10' => 'Ten', '11' => 'Eleven', '12' => 'Twelve',
        '13' => 'Thirteen', '14' => 'Fourteen',
        '15' => 'Fifteen', '16' => 'Sixteen', '17' => 'Seventeen',
        '18' => 'Eighteen', '19' => 'Nineteen', '20' => 'Twenty',
        '30' => 'Thirty', '40' => 'Forty', '50' => 'Fifty',
        '60' => 'Sixty', '70' => 'Seventy',
        '80' => 'Eighty', '90' => 'Ninety');
    $digits = array('', 'Hundred', 'Thousand', 'Lakh', 'Crore');
    
    while ($i < $digits_1) {
        $divider = ($i == 2) ? 10 : 100;
        $number = floor($no % $divider);
        $no = floor($no / $divider);
        $i += ($divider == 10) ? 1 : 2;
    
        if ($number) {
            $plural = (($counter = count($str)) && $number > 9) ? 's' : null;
            $hundred = ($counter == 1 && $str[0]) ? ' and ' : null;
            $str [] = ($number < 21) ? $words[$number] .
                " " . $digits[$counter] . $plural . " " . $hundred
                :
                $words[floor($number / 10) * 10]
                . " " . $words[$number % 10] . " "
                . $digits[$counter] . $plural . " " . $hundred;
        } else $str[] = null;
    }
    
    $str = array_reverse($str);
    $result = implode('', $str);
    
    if ($point > 20) {
        $two_deci = floor($point / 10) * 10;
        $rem = ceil($point) % 10;
        $first_point = $words[$two_deci] . " " . $words[$rem] . ' Paise only';
    } else {
        $first_point = $words[$point] . ' Paise only';
    }
    
    $points = ($point) ?
        " and " . $first_point : 'only';
    
    $pdf->Ln(5);

    $pdf->SetX(10);
    $pdf->SetFont('Arial', 'I', 10);
    $pdf->MultiCell(100, 5, 'Amount in words:');
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell(190, 5, $result . 'Rupees ' . $points, '0');

    $pdf->Ln(3);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());

    $pageHeight = $pdf->GetPageHeight();
    $currentY = $pdf->GetY();
    $threshold = $pageHeight / 2;
    
    if (($currentY + 10) > $threshold) {
        $pdf->AddPage();
    }
    
    $y_temp = $pdf->GetY() + 3;
    
    $pdf->SetY($y_temp);
    $pdf->SetFont('Arial', 'B', 12);
    $pdf->MultiCell(190, 8, 'TRANSACTION HISTORY', 0, 'C');
    $pdf->ln(3);
    $pdf->Line(10,$pdf->GetY(),200,$pdf->GetY());
        

    $start = 10;
    $row_1 = 25;
    $row_2 = 25;
    $row_3 = 110;
    $row_4 = 30;

    $y_temp = $pdf->GetY() + 3;

    $pdf->SetXY($start, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_1, 5 , 'Date');
    
    $next_x = $start + $row_1;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_2, 5 , 'Mode');

    $next_x = $next_x + $row_2;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_3, 5 , 'Payment Description');

    $next_x = $next_x + $row_3;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->MultiCell($row_4, 5 , 'Paid Amount', 0 ,'R');

    $pdf->Ln(3);
    $pdf->Line(10, $pdf->GetY(), 200, $pdf->GetY());

    $y_temp = $pdf->GetY() + 3;

    $ttl_paid = 0;
    // $sql = "SELECT * from ip_advance where patient_record_id = '$ip_id' ";
    $sql_th = "SELECT * from ip_transaction_history where record_id = '$ip_id' ";
    // $rec = mysqli_query($conn, $sql);
    $rec_2 = mysqli_query($conn, $sql_th);

    // while($data = mysqli_fetch_assoc($rec))
    // {
    //     $pdf->SetXY($start, $y_temp);
    //     $pdf->SetFont('Arial', '', 10);
    //     $pdf->MultiCell($row_1, 5 , date('d-m-Y', strtotime($data['dateTime'])));
        
    //     $next_x = $start + $row_1;

    //     $pdf->SetXY($next_x, $y_temp);
    //     $pdf->MultiCell($row_2, 5 , $data['mop']);


    //     $pdf->Ln(3);
    //     $get_line = $pdf->GetY();

    //     $next_x = $next_x + $row_2;

    //     $pdf->SetXY($next_x, $y_temp);
    //     $pdf->MultiCell($row_3, 5 , $data['remarks']);

    //     $next_x = $next_x + $row_3;

    //     $pdf->SetXY($next_x, $y_temp);
    //     $pdf->MultiCell($row_4, 5 , $data['amount'], 0 ,'R');

    //     $y_temp = $pdf->GetY() + 3;

    //     $ttl_paid = $ttl_paid + $data['amount'];
    // }

    while($data2 = mysqli_fetch_assoc($rec_2)){
        $pdf->SetXY($start, $y_temp);
        $pdf->SetFont('Arial', '', 10);
        $pdf->MultiCell($row_1, 5 , date('d-m-Y', strtotime($data2['dateTime'])));
        
        $next_x = $start + $row_1;
        $pdf->SetXY($next_x, $y_temp);
        $pdf->MultiCell($row_2, 5 , $data2['mop']);

        $pdf->Ln(3);
        $get_line = $pdf->GetY();

        $next_x = $next_x + $row_2;

        $pdf->SetXY($next_x, $y_temp);
        $pdf->MultiCell($row_3, 5 , 'IP BILL');

        $next_x = $next_x + $row_3;

        $pdf->SetXY($next_x, $y_temp);
        $pdf->MultiCell($row_4, 5 , number_format($data2['amount'] , 2), 0 ,'R');

        $y_temp = $pdf->GetY() + 3;

        $ttl_paid = $ttl_paid + $data2['amount'];
    }

    $y_temp = $pdf->GetY() + 10;
    $next_x = $start + $row_1 + $row_2;
    $pdf->SetFont('Arial', 'B', 10);
    $pdf->SetXY($next_x, $y_temp);
    $pdf->MultiCell($row_3, 5 , 'Total Paid Amount', 0 ,'R');

    $next_x = $next_x + $row_3;

    $pdf->SetXY($next_x, $y_temp);
    $pdf->MultiCell($row_4, 5 , number_format($ttl_paid) , 0 ,'R'); // sprintf('%.2f',$ttl_paid)
    

    $pdf->Output();

    $pdfFileName = 'ip_bill.pdf';
    $filePath = '../ip_bill/' . $ip_id . '/' . $pdfFileName;
    $pdf->Output($filePath, 'F');
    $pdf->Output($filePath, 'I');

?>