<?php
  include('include.php');
?>
<!DOCTYPE html>
<html lang="zxx" dir="ltr" class="light">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="">
  <title>AARTHY HOSPITAL </title>
  <link rel="icon" type="image/png" href="<?php echo $main_path; ?>assets/images/logo/favicon.svg">
  <link rel="preconnect" href="https://fonts.googleapis.com/">
  <link rel="preconnect" href="https://fonts.gstatic.com/" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css2?family=Inter:wght@300;400;500;600;700;800&amp;display=swap" rel="stylesheet">
  <!-- BEGIN: Theme CSS-->
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/rt-plugins.css">
  <link rel="stylesheet" href="<?php echo $main_path; ?>assets/css/app.css">
  <!-- End : Theme CSS -->

  <!-- Start : theme-store js -->
  <script src="<?php echo $main_path; ?>assets/js/store.js" sync></script>
  <!-- End : theme-store js -->
  <style>
    tbody>tr.data-patient:hover
    {
      background: #efefef !important;
      cursor: pointer;
    }

    .table-td{
    text-align:center !important;
  }

  .table-th{
    text-align:center !important;
  }
  .pagination-container{
    display: flex;
    flex-direction: row;
    margin-top: 20px;
    font-size: 20px;
    justify-content: end;

  }
  .col{
    background-color: #f2f3f4;
    margin-right: 20px;
    border-radius: 5px;

  }
  .search-bar-container {
            
    display: flex;
    justify-content: end;
    margin-top: 20px;
            margin-bottom: 20px;
            margin-right: 20px;
        }
        .search-bar-container label {
            margin-right: 10px; 
            margin-top: 5px;          /* Space between label and input */
            font-size: 16px;              /* Adjust the font size as needed */
        }
        .search-bar-container input {
            width: 250px;
            padding: 5px 10px;            /* Adjust the padding */
            font-size: 14px;              /* Adjust the font size */
        }


  </style>
</head>

<body class=" font-inter dashcode-app" id="body_class">
  <!-- [if IE]> <p class="browserupgrade"> You are using an <strong>outdated</strong> browser. Please <a href="https://browsehappy.com/">upgrade your browser</a> to improve your experience and security. </p> <![endif] -->
  <main class="app-wrapper">
    <!-- BEGIN: Sidebar -->
    <!-- BEGIN: Sidebar -->
    <?php include('sidebar.php') ?>
    <!-- End: Sidebar -->
    <!-- End: Sidebar -->
    <!-- BEGIN: Settings -->

    <!-- BEGIN: Settings -->
    <!-- Settings Toggle Button -->

    <!-- END: Settings -->

    <!-- End: Settings -->
    <div class="flex flex-col justify-between min-h-screen">
      <div>
        <!-- BEGIN: Header -->
        <!-- BEGIN: Header -->
        <?php include('nav.php') ?>


        <!-- BEGIN: Search Modal -->
        <div class="modal fade fixed top-0 left-0 hidden w-full h-full outline-none overflow-x-hidden overflow-y-auto inset-0 bg-slate-900/40 backdrop-filter backdrop-blur-sm backdrop-brightness-10" id="searchModal" tabindex="-1" aria-labelledby="searchModalLabel" aria-hidden="true">
          <div class="modal-dialog relative w-auto pointer-events-none top-1/4">
            <div class="modal-content border-none shadow-lg relative flex flex-col w-full pointer-events-auto bg-white dark:bg-slate-900 bg-clip-padding rounded-md outline-none text-current">
              <form>
                <div class="relative">
                  <button class="absolute left-0 top-1/2 -translate-y-1/2 w-9 h-full text-xl dark:text-slate-300 flex items-center justify-center">
                    <iconify-icon icon="heroicons-solid:search"></iconify-icon>
                  </button>
                  <input type="text" class="form-control !py-[14px] !pl-10" placeholder="Search" autofocus>
                </div>
              </form>
            </div>
          </div>
        </div>
        
        <!-- END: Search Modal -->
        <!-- END: Header -->
        <!-- END: Header -->
  <div class="content-wrapper transition-all duration-150 xl:ltr:ml-[248px] xl:rtl:mr-[248px]" id="content_wrapper">
    <div class="page-content">
        <div id="content_layout">
            <div class="grid xl:grid-cols-1 grid-cols-1 gap-6">
                <div class="card">
                    <header class="card-header noborder">
                        <h4 class="card-title">Transferred Records</h4>
                        
                    </header>
                    <div class="card-body px-6 pb-6">
                        <div class="overflow-x-auto -mx-6 dashcode">
                        <div class="search-bar-container">
                            <label for="search-bar">Search:</label>
                            <input type="text" id="search-bar" placeholder="" class="form-control">
                        </div>
                        
                            <div class="inline-block min-w-full align-middle">
                                <div class="overflow-hidden">
                                    <table class="min-w-full divide-y divide-slate-100 table-fixed dark:divide-slate-700">
                                        <thead class="bg-slate-200 dark:bg-slate-700">
                                            <tr>
                                                <th scope="col" class="table-th" style="width: 50px;">#</th>
                                                <th scope="col" class="table-th">MRD No</th>
                                                <th scope="col" class="table-th">Patient Name</th>
                                                <th scope="col" class="table-th">Doctor Name</th>
                                                <th scope="col" class="table-th">Suggested transfer</th>
                                                <th scope="col" class="table-th">Created On</th>
                                            </tr>
                                        </thead>
                                        <tbody class="bg-white divide-y divide-slate-100 dark:bg-slate-800 dark:divide-slate-700" id="patient_records">
                                            <tr>
                                                <td colspan="6" style="text-align: center;">NO DATA AVAILABLE</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div class="pagination-container">
                                      
                                      <div class="col">
                                      <svg xmlns="http://www.w3.org/2000/svg" width="1em" height="1em" viewBox="0 0 24 24"><path fill="currentColor" d="M14 17.308L8.692 12L14 6.692l.708.708l-4.6 4.6l4.6 4.6z"/></svg>
                                      </div>
                                      <div class="col">
                                      <svg xmlns="http://www.w3.org/2000/svg" width="1em" height="1em" viewBox="0 0 24 24"><path fill="currentColor" d="m13.292 12l-4.6-4.6l.708-.708L14.708 12L9.4 17.308l-.708-.708z"/></svg>
                                      </div>
                                      
                                  </div>

                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

      </div>

      <!-- BEGIN: Footer For Desktop and tab -->
      <!-- <footer id="footer">
        <div class="site-footer px-6 bg-white dark:bg-slate-800 text-slate-500 dark:text-slate-300 py-4 ltr:ml-[248px] rtl:mr-[248px]">
          <div class="grid md:grid-cols-2 grid-cols-1 md:gap-5">
            <div class="text-center ltr:md:text-start rtl:md:text-right text-sm">
              COPYRIGHT ©
              <span id="thisYear"></span>
              DashCode, All rights Reserved
            </div>
            <div class="ltr:md:text-right rtl:md:text-end text-center text-sm">
              Hand-crafted &amp; Made by
              <a href="https://codeshaper.net/" target="_blank" class="text-primary-500 font-semibold">
                Codeshaper
              </a>
            </div>
          </div>
        </div>
      </footer> -->
      <!-- END: Footer For Desktop and tab -->
     
  </main>
  <!-- scripts -->

  <script src="<?php echo $main_path; ?>assets/js/jquery-3.6.0.min.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/rt-plugins.js"></script>
  <script src="<?php echo $main_path; ?>assets/js/app.js"></script>

  <script src="<?php echo $main_path; ?>assets/toastr/build/toastr.min.js"></script> 
      <link rel="stylesheet" href="<?php echo $main_path; ?>assets/toastr/build/toastr.min.css" />

  <script>
    $(document).ready(function () {
      // search function
      $("#search-bar").on("keyup", function() {
        var value = $(this).val().toLowerCase();
        $("#patient_records tr").filter(function() {
            $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1);
        });
    });


      function fetchData() {
        var page_no = 
          $.ajax({
              url: 'ajax/entry/list_unassigned_patients.php?page_no=${page_no}',
              type: 'get',
              success: function (response) {
                  var result = JSON.parse(response);
                  var data = result.data;

                  var tbody = $('#patient_records');
                  tbody.empty(); // Clear the table body before appending new data
                  var count = 1;

                  // var dataTable = $('#data-table').DataTable();
                  // dataTable.clear();
                  // var count = 1;

                  data.forEach(function (item) {

                    var btns = `<button class="btn btn-sm btn-primary accept_btn me-1" data-record-id="${item.op_id}" data-patient-id="${item.patient_id}" data-type="${item.transfer_to}">Assign</button>`;
                                    // <button class="btn btn-sm btn-danger del_btn ms-1" data-id="${item.op_id}">Delete</button>

                      // var rowData = [
                      //     count,
                      
                      //     item.mrd_no,
                      //     item.patient_name,
                      //     item.doctor_name,
                      //     item.transfer_to,
                      //     item.created_on,
                      //     // btns
                      // ];

                      // var rowNode = dataTable.row.add(rowData).draw().node();

                      // $(rowNode).find('td').addClass('table-td');
                      // $(rowNode).attr('data-id', item.op_id);
                      // count++;

                      var patient_records = `<tr>
                              <td class="table-td">${count}</td>
                              <td class="table-td">${item.mrd_no}</td>
                              <td class="table-td">${item.patient_name}</td>
                              <td class="table-td">${item.doctor_name}</td>
                              <td class="table-td">${item.transfer_to}</td>
                               <td class="table-td">${item.created_on}</td>
                              ${btns}
                            </tr>

                            `
                            ;
                    tbody.append(patient_records);
                    count++;
                  });
              }  
            
          });
      }
      fetchData();

      

      $(document).on('click', '.accept_btn', function () {
          var id = $(this).attr('data-record-id');
          var patient_id = $(this).attr('data-patient-id');
          var type = $(this).attr('data-type');

          window.location.href = "create_ip_entry.php?patient_record_id="+id+"&patient_id="+patient_id+ "&type="+type;
          console.log(id);
      }) 

      // $(document).on('click', '.del_btn', function () {
      //     var id = $(this).attr('data-id');
      //     console.log(id);

      // })

  });




  </script>
</body>

</html>